from typing import Any, Dict

from sziszapangma.core.alignment.step_words import StepWords


class StepWordsMapper:
    @staticmethod
    def to_json_dict(step_words: StepWords) -> Dict[str, Any]:
        to_return = dict()
        if step_words.hypothesis_word is not None:
            to_return["hypothesis_word"] = step_words.hypothesis_word
        if step_words.reference_word is not None:
            to_return["reference_word"] = step_words.reference_word
        return to_return

    @staticmethod
    def from_json_dict(input_json_dict: Dict[str, Any]) -> StepWords:
        reference_word = None if "reference_word" not in input_json_dict \
            else input_json_dict["reference_word"]
        hypothesis_word = None if "hypothesis_word" not in input_json_dict \
            else input_json_dict["hypothesis_word"]
        return StepWords(reference_word, hypothesis_word)
